/* Zaklady programovani v C++
   Okomentovane priklady ze cviceni ... uvod do OOP (konstruktory, destruktory)
*/

#include <iostream>
using namespace std;

class Vektor1
{
	float *x;
	const int n;
public:
	/* konstruktor s jednim parametrem: */
	Vektor1(int _n=2) : n(_n)
	{
		cout << "vytvarim n= "<< n << endl;

		x = new float[n];
		for (int i = 0; i < n; i++)
			x[i] = i + 1; // x[i] = 0;
	}
	// destruktor:
	~Vektor1()
	{
		cout << "rusim \n";
		delete[] x;
	}
	// metoda vypis:
	void vypis()
	{
		for (int i = 0; i < n; i++)
			cout << x[i] << " ";
		cout << endl;
	}
};

int mainVektor1()
{
	{
		Vektor1 a;
		a.vypis();
	}

	Vektor1 *ub = new Vektor1;
	ub->vypis();
	delete ub;

	return 0;
}