/* Zaklady programovani v C++
   Okomentovane priklady ze cviceni ... uvod do OOP 
   Deklarace tridy Zamestnanec (3 ruzne zpusoby)
*/

#include <iostream>
#include "Zamestnanec2.h"
#include<string>
using namespace std;

class Zamestnanec1
{
// private:
	unsigned int ID = 0;
	string jmeno = "";
	string prijmeni = "";
	unsigned int plat = 0;
public:
	void nastavID(unsigned int ID)
	{
		this->ID = ID;
	}

	void nastavID1(unsigned int _ID)
	{
		ID = _ID;
	}

	void vypis()
	{
		// ekvivalentne:
		// cout << this->ID << " " << this->jmeno << " " << this->prijmeni << " " << this->plat << endl;
		cout << ID << " " << jmeno << " " << prijmeni << " " << plat << endl;

		/* Volani jine metody: */
	    // this->nastavID(45);
        // nastavID(45);
	}
};

// struct Zamestnanec
class Zamestnanec
{
// private:
	unsigned int ID = 0;
	string jmeno = "";
	string prijmeni = "";
	unsigned int plat = 0;
public:
	void nastavID(unsigned int);
	void nastavID1(unsigned int);
	void vypis();
	friend void vypis(Zamestnanec &z);
	friend int mainZamestnanec();
};

void Zamestnanec::nastavID(unsigned int ID)
{
	this->ID = ID;
}

void Zamestnanec::nastavID1(unsigned int _ID)
{
	ID = _ID;
}

/* Metoda tridy */
void Zamestnanec::vypis()
{
	cout << ID << " " << jmeno << " " << prijmeni << " " << plat << endl;
}

/* Funkce, ktera ma jako parametr (referenci na) instanci tridy */
void vypis(Zamestnanec &z)
{
	cout << z.ID << " " << z.jmeno << " " << z.prijmeni << " " << z.plat << endl;
}

int mainZamestnanec()
{
	Zamestnanec1 z1;
	z1.nastavID(45);
	z1.vypis();
	z1.nastavID(8);

	Zamestnanec z;
	z.ID = 1;
	z.jmeno = "Petr";
	z.prijmeni = "Novak";
	z.plat = 50000;
	vypis(z);
	z.vypis();

	Zamestnanec *uz = new Zamestnanec;
	uz->nastavID(7);

	uz->jmeno = "Petr";
	uz->prijmeni = "Novotny";
	uz->plat = 50000;
	vypis(*uz);
	uz->vypis();
	delete uz;

	Zamestnanec2 *z2;
	z2 = new Zamestnanec2();
	delete z2;
	{
		Zamestnanec2 z3;
	}
	
	return 0;
}